<script src="@#file#(bresenham.js)" type="text/javascript"></script>

<p>Crtanje linija izuzetno je česta operacija i nužno je da algoritmi koje koristimo budu maksimalno učinkoviti (troše minimalan broj instrukcija po svakom slikovnom elementu, i to što jeftinijih instrukcija). I dakako, želimo da algoritam bude u stanju nacrtati sve linije koje mu zadamo. U ovom trenutku fokusirajmo se na prvi spomenuti problem: možemo li koristiti "jeftinije" operacije? Prethodni algoritam za svaki je slikovni element morao obaviti množenje decimalnih brojeva i zbrajanje, nakon čega je slijedilo zaokruživanje.</p>

<p>Vratimo se stoga na početni oblik jednadžbe pravca.
\[
 y = a \cdot x + b
\]
Kako crtanje radimo za vrijednosti koordinate x iz \(\{x_0, x_0+1, x_0+2,\ldots, x_1\}\), pogledajmo koje vrijednosti dobivamo za y:
\[
\begin{align*}
 y(x_0) &amp;= a \cdot x_0 + b\\
 y(x_0+1) &amp;= a \cdot (x_0+1) + b = a \cdot x_0 + b + a = y(x_0) + a\\
 y(x_0+2) &amp;= a \cdot (x_0+2) + b = a \cdot x_0 + b + a + a = y(x_0+1) + a\\
 y(x_0+3) &amp;= a \cdot (x_0+3) + b = a \cdot x_0 + b + a + a + a = y(x_0+2) + a\\
\end{align*}
\]
Slijedi da vrijednosti pripadnih y-koordinata točaka možemo računati iterativno, tako da za svaki novi x prethodnom y-u dodamo vrijednost \(a\). Algoritam je prikazan u nastavku.
</p>

<pre>
void drawLine(int xs, int ys, int xe, int ye) {
  int x, y_pom;
  double a, y;

  a = (ye−ys)/(double)(xe−xs);
  y=ys;

  for(x=xs; x&lt;=xe; x++) {
    y_pom = zaokruzi(y);
    osvijetli_pixel(x, y_pom);
    y = y + a;
  }
}
</pre>
  <div width="500" height="500" style="position:relative;">
  <canvas id="myCanvas2" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var lineData2 = {x0: 1, y0: 1, x1: 17, y1: 8};
    var brcanvas2 = new RasterDisplay("myCanvas2", 20, 20);
    var alg2 = new BresenhamAlgorithm2(lineData2, brcanvas2);
    brcanvas2.idealLineData = lineData2;
    brcanvas2.paint();
  </script>
  drawLine(<input type="text" id="line2_x0" value="1" size="2">, <input type="text" id="line2_y0" value="1" size="2">, <input type="text" id="line2_x1" value="17" size="2">, <input type="text" id="line2_y1" value="8" size="2">)
  <button onclick="if(parseLineData('line2',lineData2)) {alg2.reset(); document.getElementById('alg2btn').disabled=false;}">Postavi</button><br>
  <button onclick="alg2.reset(); document.getElementById('alg2btn').disabled=false;">Reset</button>
  <button id="alg2btn" onclick="alg2.next(); if(!alg2.hasNext()) this.disabled=true;">Korak</button>
  <input id="alg2ch1" type="checkbox" onclick="brcanvas2.showIdealLine = document.getElementById('alg2ch1').checked ? true : false; brcanvas2.paint();"> Prikaz idealne linije

  <p>Isprobajte nacrtati sljedeće linije ovim algoritmom:</p>
  <ol>
    <li>drawLine(1,1,17,8): kut je između 0° i 45°</li>
    <li>drawLine(1,8,17,1): kut je između -45° i 0°</li>
    <li>drawLine(1,1,8,17): kut je između 45° i 90°</li>
    <li>drawLine(8,17,1,1): x-koordinata se smanjuje</li>
  </ol>
  <p>Možete li objasniti ponašanje algoritma za slučajeve 3 i 4?</p>
  <p>Kako bismo trebali modificirati algoritam za dobro radi za slučaj 3?</p>
  <p>Kako bismo trebali modificirati algoritam za dobro radi za slučaj 4?</p>
  <hr>

<p>Prednosti ovog algoritma:</p>
<ul>
<li>izbjegnuto je skupo množenje decimalnih brojeva u petlji.</li>
</ul>
<p>Nedostatci:</p>
<ul>
<li>Dobro radi samo za pravce koji su pod kutevima između -45° i +45°.</li>
<li>I dalje radimo s decimalnim brojevima.</li>
<li>Javlja se potreba za zaokruživanjem.</li>
</ul>

